Index: /trunk/kernel/fs/vfs.c
===================================================================
--- /trunk/kernel/fs/vfs.c	(revision 656)
+++ /trunk/kernel/fs/vfs.c	(revision 657)
@@ -1731,20 +1702,19 @@
                         VFS_LOOKUP_PARENT,
                         &parent_xp,
-                        name );
+                        child_name );
     if( error ) 
     {
         remote_rwlock_wr_release( lock_xp );
         printk("\n[ERROR] in %s : cannot get parent inode for <%s> in <%s>\n",
-        __FUNCTION__, name, path );
+        __FUNCTION__, child_name, path );
         return -1;
     }
-
-    // get parent inode cluster and local pointer
+    
+    // get parent inode name, cluster and local pointer
+    vfs_inode_get_name( parent_xp , parent_name );
     parent_cxy = GET_CXY( parent_xp );
     parent_ptr = GET_PTR( parent_xp );
  
 #if( DEBUG_VFS_UNLINK & 1 )
-char parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_inode_get_name( parent_xp , parent_name );
 if( DEBUG_VFS_UNLINK < cycle )
 printk("\n[%s] thread[%x,%x] : parent inode <%s> is (%x,%x)\n",
@@ -1756,7 +1726,7 @@
 
     // try to get extended pointer on dentry from Inode Tree
-    dentry_xp = xhtab_lookup( children_xp , name );
+    dentry_xp = xhtab_lookup( children_xp , child_name );
     
-    // when dentry not found in Inode Tree, try to get it from inode tree
+    // when dentry not found in Inode Tree, try to get it from mapper
 
     if( dentry_xp == XPTR_NULL )           // miss target dentry in Inode Tree
@@ -1765,6 +1735,6 @@
 #if( DEBUG_VFS_UNLINK & 1 )
 if( DEBUG_VFS_UNLINK < cycle )
-printk("\n[%s] thread[%x,%x] : inode <%s> not found => scan parent mapper\n",
-__FUNCTION__, process->pid, this->trdid, name );
+printk("\n[%s] thread[%x,%x] : inode <%s> not found => scan parent mapper <%s>\n",
+__FUNCTION__, process->pid, this->trdid, child_name , parent_name );
 #endif
         // get parent inode FS type
@@ -1779,13 +1749,11 @@
                                          fs_type, 
                                          parent_xp, 
-                                         name, 
+                                         child_name, 
                                          &dentry_xp,
                                          &inode_xp );
         if( error )
         {
-            printk("\n[ERROR] in %s : cannot create inode <%s> in path <%s>\n",
-            __FUNCTION__ , name, path );
-
-            vfs_remove_child_from_parent( dentry_xp );
+            printk("\n[ERROR] in %s : cannot create inode <%s> in Inode Tree\n",
+            __FUNCTION__ , child_name );
             return -1;
         }
@@ -1797,23 +1765,10 @@
         // scan parent mapper to find the missing dentry, and complete 
         // initialisation of new dentry and new inode descriptors In Inode Tree
-        if( parent_cxy == local_cxy )
+        error = vfs_fs_new_dentry_from_mapper( parent_xp,
+                                               dentry_ptr );
+        if ( error ) 
         {
-            error = vfs_fs_new_dentry( parent_ptr,
-                                       name,
-                                       inode_xp );
-        }
-        else
-        {
-            rpc_vfs_fs_new_dentry_client( parent_cxy,
-                                          parent_ptr,
-                                          name,
-                                          inode_xp,
-                                          &error );
-        }
-
-        if ( error )   // dentry not found in parent mapper
-        {
-            printk("\n[ERROR] in %s : cannot get dentry <%s> in path <%s>\n",
-            __FUNCTION__ , name, path );
+            printk("\n[ERROR] in %s : cannot get entry <%s> in parent <%s> mapper\n",
+            __FUNCTION__ , child_name, parent_name );
             return -1;
         }
@@ -1822,5 +1777,5 @@
 if( DEBUG_VFS_UNLINK < cycle )
 printk("\n[%s] thread[%x,%x] : created missing inode & dentry <%s> in cluster %x\n",
-__FUNCTION__, process->pid, this->trdid, name, inode_cxy );
+__FUNCTION__, process->pid, this->trdid, child_name, inode_cxy );
 #endif
 
@@ -1856,5 +1811,6 @@
 if( DEBUG_VFS_UNLINK < cycle )
 printk("\n[%s] thread[%x,%x] : unlink inode <%s> / type %s / %d links\n",
-__FUNCTION__, process->pid, this->trdid, name, vfs_inode_type_str(inode_type), inode_links );
+__FUNCTION__, process->pid, this->trdid, child_name, 
+vfs_inode_type_str(inode_type), inode_links );
 #endif
 
@@ -1898,17 +1854,6 @@
         // 2. update parent directory mapper
         //    and synchronize the parent directory on IOC device
-        if (parent_cxy == local_cxy)
-        {
-            error = vfs_fs_remove_dentry( parent_ptr,
-                                          dentry_ptr );
-        }
-        else            
-        {
-            rpc_vfs_fs_remove_dentry_client( parent_cxy,
-                                             parent_ptr,
-                                             dentry_ptr,
-                                             &error );
-        }
-
+        error = vfs_fs_remove_dentry( parent_xp,
+                                      dentry_ptr );
         if( error )
         {
@@ -2172,5 +2117,5 @@
 
 //////////////////////////////////////////////////////////////////////////
-// This static function is called by the vfs_display() function.
+// This recursive function is called by the vfs_display() function.
 // that is supposed to take the TXT0 lock.
 //////////////////////////////////////////////////////////////////////////
@@ -2184,5 +2129,4 @@
     uint32_t           inode_size;
     uint32_t           inode_attr;
-    uint32_t           inode_dirty;
     void             * inode_extd;
 
@@ -2234,10 +2178,10 @@
 
     // compute dirty
-    inode_dirty = ((inode_attr & INODE_ATTR_DIRTY) != 0);
+    // inode_dirty = ((inode_attr & INODE_ATTR_DIRTY) != 0); unused [AG] dec 2019
 
     // display inode
-    nolock_printk("%s<%s> : %s / extd %x / %d bytes / dirty %d / cxy %x / inode %x / mapper %x\n",
+    nolock_printk("%s<%s> : %s / extd %x / %d bytes / cxy %x / inode %x / mapper %x\n",
     indent_str[indent], name, vfs_inode_type_str( inode_type ), (uint32_t)inode_extd,
-    inode_size, inode_dirty, inode_cxy, inode_ptr, mapper_ptr );
+    inode_size, inode_cxy, inode_ptr, mapper_ptr );
 
     // scan directory entries when current inode is a directory
@@ -2328,5 +2272,5 @@
 
     // print header
-    nolock_printk("\n***** file system state\n\n");
+    nolock_printk("\n***** current VFS state\n\n");
 
     // call recursive function
@@ -2484,4 +2428,5 @@
     vfs_inode_t      * parent_ptr;   // local pointer on parent inode  
     xptr_t             dentry_xp;    // extended pointer on dentry       
+    vfs_dentry_t     * dentry_ptr;   // local pointer on dentry
     xptr_t             child_xp;     // extended pointer on child inode
     cxy_t              child_cxy;    // cluster for child inode
@@ -2532,4 +2477,6 @@
     last      = false;
     child_xp  = XPTR_NULL;
+    child_cxy = 0;
+    child_ptr = NULL;
 
     // loop on nodes in pathname
@@ -2570,9 +2517,5 @@
                                &child_xp );
 
-        // get child inode local pointer and cluster
-        child_ptr  = GET_PTR( child_xp );
-        child_cxy  = GET_CXY( child_xp );
-
-        if( found == false )                              // not found in Inode Tree 
+        if( found == false )                          // child not found in Inode Tree 
         {
             // when a inode is not found in the Inode Tree:
@@ -2606,5 +2549,5 @@
 #endif
                 // get parent inode FS type
-                ctx_ptr    = hal_remote_lpt( XPTR( parent_cxy,&parent_ptr->ctx ) );
+                ctx_ptr    = hal_remote_lpt( XPTR( parent_cxy , &parent_ptr->ctx ) );
                 fs_type    = hal_remote_l32( XPTR( parent_cxy , &ctx_ptr->type ) );
 
@@ -2626,6 +2569,7 @@
                 }
 
-                // get child inode local pointer
-                child_ptr = GET_PTR( child_xp );
+                // get child inode and dentry local pointers
+                child_ptr  = GET_PTR( child_xp );
+                dentry_ptr = GET_PTR( dentry_xp );
 
 #if (DEBUG_VFS_LOOKUP & 1)
@@ -2636,32 +2580,17 @@
                 // scan parent mapper to find the missing dentry, and complete 
                 // the initialisation of dentry and child inode descriptors
-                if( parent_cxy == local_cxy )
-                {
-                    error = vfs_fs_new_dentry( parent_ptr,
-                                               name,
-                                               child_xp );
-                }
-                else
-                {
-                    rpc_vfs_fs_new_dentry_client( parent_cxy,
-                                                  parent_ptr,
-                                                  name,
-                                                  child_xp,
-                                                  &error );
-                }
-
-                // when the missing dentry is not in the parent mapper,
-                // a new dentry must be registered in parent directory mapper
-                if ( error )
+                error = vfs_fs_new_dentry_from_mapper( parent_xp,
+                                                       dentry_ptr );
+
+                if ( error )  // an error can be fatal or non-fatal :
                 {
                     if ( last && create )  // add a brand new dentry in parent directory
                     {
-                        error = vfs_new_dentry_init( parent_xp,                
-                                                     dentry_xp,
-                                                     child_xp );
+                        error = vfs_fs_new_dentry_to_mapper( parent_xp,                
+                                                             dentry_ptr );
                         if ( error )
                         {
-                            printk("\n[ERROR] in %s : cannot init inode <%s> in path <%s>\n",
-                            __FUNCTION__, name, pathname );
+                            printk("\n[ERROR] in %s : cannot add dentry <%s> in parent dir\n",
+                            __FUNCTION__, name );
                             vfs_remove_child_from_parent( dentry_xp );
                             return -1;
@@ -2674,6 +2603,4 @@
 vfs_inode_display( child_xp );
 #endif
-
-
                     }
                     else                   // not last or not create => error
@@ -2704,14 +2631,6 @@
                     if( type == INODE_TYPE_DIR ) 
                     {
-                        if( child_cxy == local_cxy )
-                        {
-                            error = vfs_inode_load_all_pages( child_ptr );
-                        }
-                        else
-                        {
-                            rpc_vfs_inode_load_all_pages_client( child_cxy,
-                                                                 child_ptr,
-                                                                 &error );
-                        }
+                        error = vfs_inode_load_all_pages( child_xp );
+
                         if ( error )
                         {
@@ -2731,6 +2650,9 @@
             }
         }
-        else                                    // child directly found in inode tree
+        else                                    // child found in Inode Tree
         {
+            // get child inode local pointer and cluster
+            child_ptr  = GET_PTR( child_xp );
+            child_cxy  = GET_CXY( child_xp );
         
 #if (DEBUG_VFS_LOOKUP & 1)
@@ -2759,8 +2681,4 @@
         // }
 
-        // take lock on child inode and release lock on parent
-        // vfs_inode_lock( child_xp );
-        // vfs_inode_unlock( parent_xp );
-
         // exit when last
         if ( last )           // last inode in path  => return relevant info
@@ -2792,106 +2710,19 @@
             }
         }
-        else                     // not the last inode in path => update loop variables
+        else                     // not the last node in path => update loop variables
         {
             parent_xp = child_xp;
             current   = next;
         }
-    }
+    }  // end while loop on nodes in pathname
+
+#if ( DEBUG_VFS_LOOKUP & 1 )
+if( DEBUG_VFS_LOOKUP < cycle )
+vfs_display( root_xp );
+#endif
 
     return 0;
 
 }  // end vfs_lookup()
-
-////////////////////////////////////////////////
-error_t vfs_new_dentry_init( xptr_t   parent_xp,
-                             xptr_t   dentry_xp,
-                             xptr_t   child_xp )
-{
-    error_t     error;
-    uint32_t    cluster_id;
-    uint32_t    child_type;
-    uint32_t    child_size;
-
-#if DEBUG_VFS_NEW_DENTRY_INIT
-char parent_name[CONFIG_VFS_MAX_NAME_LENGTH];
-char child_name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_inode_get_name( parent_xp , parent_name );
-vfs_inode_get_name( child_xp  , child_name );
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-thread_t * this  = CURRENT_THREAD;
-if( DEBUG_VFS_NEW_DENTRY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] enter / parent <%s> / child <%s> / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, parent_name, child_name, cycle );
-#endif
-
-    // get parent inode cluster and local pointer
-    cxy_t          parent_cxy = GET_CXY( parent_xp );
-    vfs_inode_t  * parent_ptr = GET_PTR( parent_xp );
-
-    // get dentry local pointer
-    vfs_dentry_t * dentry_ptr = GET_PTR( dentry_xp );
-
-    // get child inode cluster and local pointer
-    cxy_t          child_cxy  = GET_CXY( child_xp );
-    vfs_inode_t  * child_ptr  = GET_PTR( child_xp );
-
-    // 1. allocate one free cluster_id in file system to child inode,
-    // and update the File Allocation Table in both the FAT mapper and IOC device.
-    // It depends on the child inode FS type.
-    vfs_ctx_t * ctx = hal_remote_lpt( XPTR( child_cxy , &child_ptr->ctx ) );
-
-    error = vfs_fs_cluster_alloc( ctx->type,
-                                  &cluster_id );
-    if ( error )
-    {
-        printk("\n[ERROR] in %s : cannot find a free VFS cluster_id\n",
-        __FUNCTION__ );
-        return -1;
-    }
-
-#if( DEBUG_VFS_NEW_DENTRY_INIT & 1)
-if( DEBUG_VFS_NEW_DENTRY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] allocated FS cluster_id %x to <%s>\n",
-__FUNCTION__ , this->process->pid, this->trdid, cluster_id, child_name );
-#endif
-
-    // 2. update the child inode descriptor size and extend
-    child_type = hal_remote_l32( XPTR( child_cxy , &child_ptr->type ) );
-    child_size = 0;
-    
-    hal_remote_s32( XPTR( child_cxy , &child_ptr->size )   , child_size );
-    hal_remote_spt( XPTR( child_cxy , &child_ptr->extend ) , (void*)(intptr_t)cluster_id );
-
-    // 3. update the parent inode mapper, and 
-    // update the dentry extension if required
-    if( local_cxy == parent_cxy )
-    {
-        error = vfs_fs_add_dentry( parent_ptr,
-                                   dentry_ptr );
-    }
-    else
-    {
-        rpc_vfs_fs_add_dentry_client( parent_cxy,
-                                      parent_ptr,
-                                      dentry_ptr,
-                                      &error );
-    }
-    if ( error )
-    {
-        printk("\n[ERROR] in %s : cannot register child in parent directory\n",
-        __FUNCTION__ );
-        return -1;
-    }
-
-#if DEBUG_VFS_NEW_DENTRY_INIT
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_VFS_NEW_DENTRY_INIT < cycle )
-printk("\n[%s] thread[%x,%x] exit / parent <%s> / child <%s> / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid, parent_name, child_name, cycle );
-#endif
-
-    return 0;
-
-}  // end vfs_new_dentry_init()
 
 ///////////////////////////////////////////////////
@@ -2906,7 +2737,4 @@
     xptr_t          dentry_xp;         // extended pointer on dentry (used for . and ..)
     vfs_dentry_t  * dentry_ptr;        // local pointer on dentry (used for . and ..) 
-
-    // xptr_t          parents_root_xp;   // extended pointer on inode "parents" field
-    // xptr_t          parents_entry_xp;  // extended pointer on dentry "parents" field
     xptr_t          children_xhtab_xp; // extended pointer on inode "children" field
     xptr_t          children_entry_xp; // extended pointer on dentry "children" field
@@ -2924,5 +2752,5 @@
 #endif
 
-    // get new directory cluster and local pointer
+    // get child directory cluster and local pointer
     child_cxy  = GET_CXY( child_xp );
     child_ptr  = GET_PTR( child_xp );
@@ -2933,18 +2761,8 @@
 
     //////////////////////////// create <.> dentry //////////////////////
-    if( child_cxy == local_cxy )     
-    {
-        error = vfs_dentry_create( fs_type,
-                                   ".",
-                                   &dentry_xp );
-    }
-    else
-    {
-        rpc_vfs_dentry_create_client( child_cxy,
-                                      fs_type,
-                                      ".",
-                                      &dentry_xp,
-                                      &error );
-    }
+    error = vfs_dentry_create( child_cxy,
+                               fs_type,
+                               ".",
+                               &dentry_xp );
     if( error )
     {
@@ -2967,5 +2785,7 @@
     children_xhtab_xp = XPTR( child_cxy , &child_ptr->children );
     children_entry_xp = XPTR( child_cxy , &dentry_ptr->children );
+
     error = xhtab_insert( children_xhtab_xp , "." , children_entry_xp );
+
     if( error )
     {
@@ -2974,12 +2794,5 @@
         return -1;
     }
-
     
-    // don't register <.> dentry in child_inode xlist of parents 
-    // parents_root_xp  = XPTR( child_cxy , &child_ptr->parents );
-    // parents_entry_xp = XPTR( child_cxy , &dentry_ptr->parents );
-    // xlist_add_first( parents_root_xp , parents_entry_xp );
-    // hal_remote_atomic_add( XPTR( child_cxy , &child_ptr->links ) , 1 );
-
     // update "parent" and "child_xp" fields in <.> dentry
     hal_remote_s64( XPTR( child_cxy , &dentry_ptr->child_xp ) , child_xp );
@@ -2997,16 +2810,6 @@
     if( child_xp != parent_xp )
     {
-        if( child_cxy == local_cxy )
-        { 
-            error = vfs_fs_add_dentry( child_ptr,
-                                       dentry_ptr );
-        }
-        else
-        {
-            rpc_vfs_fs_add_dentry_client( child_cxy,
-                                          child_ptr,
-                                          dentry_ptr,
-                                          &error );
-        }
+        error = vfs_fs_add_dentry( child_xp,
+                                   dentry_ptr );
         if( error )
         {
@@ -3026,18 +2829,8 @@
 
     ///////////////////////////// create <..> dentry ///////////////////////
-    if( child_cxy == local_cxy )     
-    {
-        error = vfs_dentry_create( fs_type,
-                                   "..",
-                                   &dentry_xp );
-    }
-    else
-    {
-        rpc_vfs_dentry_create_client( child_cxy,
-                                      fs_type,
-                                      "..",
-                                      &dentry_xp,
-                                      &error );
-    }
+    error = vfs_dentry_create( child_cxy,
+                               fs_type,
+                               "..",
+                               &dentry_xp );
     if( error )
     {
@@ -3085,16 +2878,6 @@
     if( child_xp != parent_xp )
     {
-        if( child_cxy == local_cxy )
-        { 
-            error = vfs_fs_add_dentry( child_ptr,
-                                       dentry_ptr );
-        }
-        else
-        {
-            rpc_vfs_fs_add_dentry_client( child_cxy,
-                                          child_ptr,
-                                          dentry_ptr,
-                                          &error );
-        }
+        error = vfs_fs_add_dentry( child_xp,
+                                   dentry_ptr );
         if( error )
         {
@@ -3259,5 +3042,5 @@
 
       
-////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////
 error_t vfs_add_child_in_parent( cxy_t              child_cxy,
                                  vfs_fs_type_t      fs_type,
@@ -3296,19 +3079,8 @@
 
     // 1. create dentry in parent cluster
-    if( parent_cxy == local_cxy )           // parent cluster is local
-    {
-        error = vfs_dentry_create( fs_type,
-                                   name,
-                                   &new_dentry_xp );
-    }
-    else                                    // parent cluster is remote
-    {
-        rpc_vfs_dentry_create_client( parent_cxy,
-                                      fs_type,
-                                      name,
-                                      &new_dentry_xp,
-                                      &error );
-    }
-                                      
+    error = vfs_dentry_create( parent_cxy,
+                               fs_type,
+                               name,
+                               &new_dentry_xp );
     if( error )
     {
@@ -3334,25 +3106,11 @@
     uint32_t gid  = 0;
     
-    if( child_cxy == local_cxy )      // child cluster is local 
-    {
-        error = vfs_inode_create( fs_type,
-                                  attr,
-                                  mode,
-                                  uid,
-                                  gid,
-                                  &new_inode_xp );
-    }
-    else                              // child cluster is remote
-    {
-        rpc_vfs_inode_create_client( child_cxy,
-                                     fs_type,
-                                     attr,
-                                     mode,
-                                     uid,
-                                     gid,
-                                     &new_inode_xp,
-                                     &error );
-    }
-                                     
+    error = vfs_inode_create( child_cxy,
+                              fs_type,
+                              attr,
+                              mode,
+                              uid,
+                              gid,
+                              &new_inode_xp );
     if( error )
     {
@@ -3360,6 +3118,5 @@
                __FUNCTION__ , child_cxy );
  
-        if( parent_cxy == local_cxy ) vfs_dentry_destroy( new_dentry_ptr );
-        else rpc_vfs_dentry_destroy_client( parent_cxy , new_dentry_ptr );
+        vfs_dentry_destroy( new_dentry_xp );
         return -1;
     }
@@ -3374,5 +3131,4 @@
 #endif
 
-
     // 3. register new_dentry in new_inode xlist of parents 
     parents_root_xp  = XPTR( child_cxy , &new_inode_ptr->parents );
@@ -3457,26 +3213,8 @@
 
     // delete dentry descriptor
-    if( parent_cxy == local_cxy )
-    {
-         vfs_dentry_destroy( dentry_ptr );
-    }
-    else
-    {
-         rpc_vfs_dentry_destroy_client( parent_cxy,
-                                        dentry_ptr );
-    }
+    vfs_dentry_destroy( dentry_xp );
 
     // delete child_inode descriptor if last link
-    if( links == 1 )
-    {
-        if( child_cxy == local_cxy )
-        {
-            vfs_inode_destroy( child_inode_ptr );
-        }
-        else
-        {
-            rpc_vfs_inode_destroy_client( child_cxy , child_inode_ptr );
-        }
-    }
+    if( links == 1 )  vfs_inode_destroy( child_inode_xp );
 
 }  // end vfs_remove_child_from_parent()
@@ -3489,35 +3227,36 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 
-//////////////////////////////////////////////
-error_t vfs_fs_move_page( xptr_t      page_xp,
-                          cmd_type_t  cmd_type )
+///////////////////////////////////////////////////
+error_t vfs_fs_add_dentry( xptr_t         inode_xp,
+                           vfs_dentry_t * dentry_ptr )
 {
     error_t error = 0;
 
-assert( (page_xp != XPTR_NULL) , "page pointer is NULL" );
-
-    page_t * page_ptr = GET_PTR( page_xp );
-    cxy_t    page_cxy = GET_CXY( page_xp );
-
-    // get local pointer on page mapper
-    mapper_t * mapper = hal_remote_lpt( XPTR( page_cxy , &page_ptr->mapper ) );
-
-assert( (mapper != NULL) , "no mapper for page" );
+assert( (inode_xp   != XPTR_NULL) , "inode_xp argument is NULL" );
+assert( (dentry_ptr != NULL     ) , "dentry_ptr argument is NULL" );
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
 
     // get FS type
-    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( page_cxy , &mapper->type ) );
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_move_page( page_xp , cmd_type ); 
+        error = fatfs_add_dentry( inode_xp , dentry_ptr ); 
     }
     else if( fs_type == FS_TYPE_RAMFS )
     {
-        assert( false , "should not be called for RAMFS\n" );
+        error = 0;     // does nothing for RAMFS
     }
     else if( fs_type == FS_TYPE_DEVFS )
     {
-        assert( false , "should not be called for DEVFS\n" );
+        error = 0;     // does nothing for DEVFS
     }
     else
@@ -3528,26 +3267,31 @@
     return error;
 
-}  // end vfs_fs_move_page()
-
-////////////////////////////////////////////////
-error_t vfs_fs_add_dentry( vfs_inode_t  * inode,
-                           vfs_dentry_t * dentry )
+}  // end vfs_fs_add_dentry()
+
+//////////////////////////////////////////////////////
+error_t vfs_fs_remove_dentry( xptr_t         inode_xp,
+                              vfs_dentry_t * dentry_ptr )
 {
     error_t error = 0;
 
-assert( (inode  != NULL) , "inode  pointer is NULL" );
-assert( (dentry != NULL) , "dentry pointer is NULL" );
-
-    mapper_t * mapper = inode->mapper;
-
-assert( (mapper != NULL) , "mapper pointer is NULL" );
+assert( (inode_xp   != XPTR_NULL) , "inode_xp argument is NULL" );
+assert( (dentry_ptr != NULL     ) , "dentry_ptr argument is NULL" );
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
 
     // get FS type
-    vfs_fs_type_t fs_type = mapper->type;
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_add_dentry( inode , dentry ); 
+        error = fatfs_remove_dentry( inode_xp , dentry_ptr ); 
+
     }
     else if( fs_type == FS_TYPE_RAMFS )
@@ -3566,34 +3310,38 @@
     return error;
 
-}  // end vfs_fs_add_dentry()
-
-///////////////////////////////////////////////////
-error_t vfs_fs_remove_dentry( vfs_inode_t  * inode,
-                              vfs_dentry_t * dentry )
+}  // end vfs_fs_remove_dentry()
+
+///////////////////////////////////////////////////////////////
+error_t vfs_fs_new_dentry_from_mapper( xptr_t         inode_xp,
+                                       vfs_dentry_t * dentry_ptr )
 {
     error_t error = 0;
 
-assert( (inode  != NULL) , "inode  pointer is NULL" );
-assert( (dentry != NULL) , "dentry pointer is NULL" );
-
-    mapper_t * mapper = inode->mapper;
-
-assert( (mapper != NULL) , "mapper pointer is NULL" );
+assert( (inode_xp   != XPTR_NULL) , "inode_xp argument is NULL" );
+assert( (dentry_ptr != NULL     ) , "dentry_ptr argument is NULL" );
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
 
     // get FS type
-    vfs_fs_type_t fs_type = mapper->type;
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_remove_dentry( inode , dentry ); 
+        error = fatfs_new_dentry_from_mapper( inode_xp , dentry_ptr );
     }
     else if( fs_type == FS_TYPE_RAMFS )
     {
-        error = 0;     // does nothing for RAMFS
+        assert( false , "should not be called for RAMFS" );
     }
     else if( fs_type == FS_TYPE_DEVFS )
     {
-        error = 0;     // does nothing for DEVFS
+        assert( false , "should not be called for DEVFS" );
     }
     else
@@ -3604,24 +3352,30 @@
     return error;
 
-}  // end vfs_fs_remove_dentry()
-
-////////////////////////////////////////////////
-error_t vfs_fs_new_dentry( vfs_inode_t * parent,
-                           char        * name,
-                           xptr_t        child_xp )
+} // end vfs_fs_new_dentry_from_mapper()
+
+///////////////////////////////////////////////////////////////
+error_t vfs_fs_new_dentry_to_mapper( xptr_t         inode_xp,
+                                     vfs_dentry_t * dentry_ptr )
 {
     error_t error = 0;
 
-// check arguments
-assert( (parent != NULL) , "parent pointer is NULL");
-assert( (child_xp != XPTR_NULL) , "child pointer is NULL");
-
-    // get parent inode FS type
-    vfs_fs_type_t fs_type = parent->ctx->type;
+assert( (inode_xp   != XPTR_NULL) , "inode_xp argument is NULL" );
+assert( (dentry_ptr != NULL     ) , "dentry_ptr argument is NULL" );
+
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get inode mapper
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+assert( (mapper != NULL) , "mapper pointer is NULL")        
+
+    // get FS type
+    vfs_fs_type_t fs_type = hal_remote_l32( XPTR( inode_cxy , &mapper->fs_type ) );
 
     // call relevant FS function
     if( fs_type == FS_TYPE_FATFS )
     {
-        error = fatfs_new_dentry( parent , name , child_xp );
+        error = fatfs_new_dentry_to_mapper( inode_xp , dentry_ptr );
     }
     else if( fs_type == FS_TYPE_RAMFS )
